#include "config.h"

#include <stdlib.h>

#include "sixtp-dom-parsers.h"
#include "sixtp-dom-generators.h"

#include "test-stuff.h"

#include "guid.h"
#include "date.h"
#include "gnc-numeric.h"

static void
test_binary()
{
    int i;
    for(i = 0; i < 20; i++)
    {
        bin_data *test_data1;
        void *test_data2;
        guint64 test_data2_len;
        gchar *converted;
        
        test_data1 = get_random_binary_data();

        converted = binary_to_string(test_data1->data, test_data1->len);

        if(!converted)
        {
            failure(i, "binary_data", "binary_to_string returned NULL");
            continue;
        }

        if(!string_to_binary(converted, &test_data2, &test_data2_len))
        {
            failure(i, "binary_data", "string_to_binary returned FALSE with data:\n%s\n", converted);
            continue;
        }

        if(test_data2_len != test_data1->len)
        {
            failure(i, "binary_data", "lengths don't match: %lld vs %lld",
                    test_data2_len, test_data1->len);
            continue;
        }
        
        {
            int j;
            guchar *d1 = test_data1->data;
            guchar *d2 = (guchar*)test_data2;
            
            for(j = 0; j < test_data2_len; j++)
            {
                if(d1[j] != d2[j])
                {
                    failure(i, "binary_data", "data doesn't match at point %d.\n%d vs %d", i, d1[j], d2[j]);
                    continue;
                }
            }
        }

        success(i, "binary_data", "");
    }
}

int
main(int argc, char **argv)
{
    test_binary();
    
    exit(get_rv());
}
